package com.zksy.web.controller.basicData;


import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmEnvironmentalCreditEvaluationNotification;
import com.zksy.system.basicData.service.CrmEnvironmentalCreditEvaluationNotificationService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.List;

/**
 * 环保信用评价结果的通知Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmEnvironmentalCreditEvaluationNotification")
@Api(tags = "环保信用评价结果的通知", description = "环保信用评价结果的通知desc")
public class CrmEnvironmentalCreditEvaluationNotificationController extends BaseController {

    @Autowired
    private CrmEnvironmentalCreditEvaluationNotificationService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "环保信用评价结果的通知搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "环保信用评价结果的通知分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "环保信用评价结果的通知查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增环保信用评价结果的通知
     */
    @PostMapping("/save")
    @ApiOperation(value = "环保信用评价结果的通知新增")
    @Log(title = "新增环保信用评价结果的通知", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmEnvironmentalCreditEvaluationNotification crmEnvironmentalCreditEvaluationNotification) {
        return service.save(crmEnvironmentalCreditEvaluationNotification);
    }

    /**
     * 修改环保信用评价结果的通知
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "环保信用评价结果的通知修改")
    @Log(title = "修改环保信用评价结果的通知", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmEnvironmentalCreditEvaluationNotification crmEnvironmentalCreditEvaluationNotification) {
        return service.updateById(crmEnvironmentalCreditEvaluationNotification);
    }
    /**
     * 导入环保信用评价结果的通知
     */
    @ApiOperation("环保信用评价结果的通知导入")
    @Log(title = "环保信用评价结果的通知", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmEnvironmentalCreditEvaluationNotification> crmEnvironmentalCreditEvaluationNotificationAll = service.list();
            List<CrmEnvironmentalCreditEvaluationNotification> list = ExcelUtils.readMultipartFile(file, CrmEnvironmentalCreditEvaluationNotification.class,CrmEnvironmentalCreditEvaluationNotification.class.getDeclaredFields().length - 2);
            if(crmEnvironmentalCreditEvaluationNotificationAll != null && crmEnvironmentalCreditEvaluationNotificationAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("环保信用评价结果的通知导出")
    @Log(title = "环保信用评价结果的通知", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmEnvironmentalCreditEvaluationNotification> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"环保信用评价结果的通知",wrapperList,CrmEnvironmentalCreditEvaluationNotification.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "环保信用评价结果的通知", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除环保信用评价结果的通知", notes = "删除环保信用评价结果的通知")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }
    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"环保信用评价模板");
    }
}

